%% ------------------------------------------------------------------------- %%
\chapter{Background}
\label{cap:bkg}

%% ------------------------------------------------------------------------- %%
\section{Free/Libre Open Source Software}
\label{sec:floss}

%% ------------------------------------------------------------------------- %%
%\subsection{History}
%\label{sec:history}

The movements of Free Software and Open Source has in their bases the opposition
to the policies and models of software development practiced by much of the
industry in their times. While the Free Software movement was in opposition to the
domain of the proprietary software industry, the Open Source advocated the
superiority of a kind of anarchic development model over the hierarchical model
normally used in proprietary software projects. Therefore, revisiting the history
of Free and Open Source Software is essential for finding loose ends that remain in
academic studies 36 years after the beginning of the Free Software
movement and 21 years of Open Source, and that still represent a challenge for
the understanding of possibilities of this model.

%% ------------------------------------------------------------------------- %%
\subsubsection{Free Software Movement}
\label{sec:freeMov}

The first steps of the Free Software movement were given in 1983 when Richard
Stallman announced the GNU project. The goal of the project was to build a
Unix-compatible operating system to be made
available for free~\citep{stallman_1983,stallman_gnu}. In Stallman's view, the existence of a free
operating system would strengthen the cooperative development of computing
communities~\citep{gnu_history} that had been weakened by the dominance of the private software
industry. This movement was consolidated two years later with the publication of
the GNU Manifesto in Dr. Dobb's Journal of Software Tools and with the creation
of the Free Software Foundation, which, in addition to supporting the GNU
project, aimed to promote the development and use of free software and ensure
the freedom to copy, study, modify, and redistribute software. Also, in 1989, the same
project created the ``GNU General Public License'' (GPL)~\citep{gpl}, a copyleft scheme that
eliminates the use restrictions in software, as well as other
productions.

Only in 1992, with the incorporation of the Linux kernel, the GNU project was
able to create a complete operating system. The existence of a free operating
system and the success of the GNU/Linux project led to the growth of software
projects under the GPL license and its volunteer communities which, in turn,
led to increased commercial interests in the development process.

%% ------------------------------------------------------------------------- %%
\subsubsection{Open Source Movement}
\label{sec:osMov}

In 1997, through a set of observations made in the Linux kernel community and
lessons learned from his experiences with other software projects, Eric Raymond
presented the essay ``The Cathedral and the Bazaar''. In this essay, Raymond
defines two antagonistic models of software development: the cathedral model and
the bazaar model. Projects classified as cathedrals would be those projects that
follow a hierarchical model of development, with long periods between the release of
new versions and little participation of the users in the software construction
process. The bazaar, similar to the Linux model, is open to receiving any
contribution from any user, with short releases and assuming the risk of
failures and bugs. For him, the bazaar model
was like a horde of anarchists competing and surpassing the hierarchical form of
closed software development.

From this essay and subsequent publications, Raymond coined the term Open Source
that aimed to propagate a depoliticized and ideologically biased concept of free
software projects of the time. Raymond defined that the bazaar development
model, or Linux model, would be the model to be followed by open source
software. The initial set of characteristics of the Linux development, describing it
as a large bazaar, the benefits generated by adopting the model the clear and
non-accountability or relationship with moral issues intensified the
participation of commercial actors in free software projects and open code. The
premises ``Release early and often. Delegate everything you can. Be open to the
point of promiscuity.'' won the sympathy not only of the developers and users of
the projects but also of companies that could see advantages in innovation and
improvement of their products with the opening of the code for contributions.

Given the rise of the term open source, this essay has become a landmark for the
universe of free software until now. While on the one hand, the essay sowed the
investigation, understanding, and implementation of good practices of OSS
development, on the other hand, the defense of the term open source as an
apolitical synonym of free software disturbed some practitioners of the time and
generated a rupture between them. This rupture becomes clear when Stallman
published an online article stating that Open Source software misses the point
of Free software~\citep{stallman_2019}. 

%TODO: Or even in the comings and goings of Perens about the development of Debian project: Open Source or Free Software?.

%% ------------------------------------------------------------------------- %%
\subsection{FLOSS Development Model}
\label{sec:FLOSSDevMod}

According to \cite{Mockus2002}, FLOSS processes can produce high-quality and
widely deployed software; however, the exact means responsible for the success,
are frequently debated. Meritocracy, cooperative spirit, and code transparency
are all part of this, but they are not enough to explain the daily routine
of a project and also how they resolve conflicts~\citep{Fogel2005}.

We can consider as a preliminary initiative to characterize freely licensed
software development models, the Cathedral and Bazaar models presented by
\cite{Raymond1999}. When observing free software projects of that time, Raymond
separated in two sets the characteristics found by him in a personal project
and projects like Linux and GCC, as summarized below:

\textbf{The Cathedral}

\begin{itemize}
	\item \textbf{Development team:} a group of few people, well-trained and working in isolation.
	\item \textbf{Release process:} does not include beta versions. Do not release a version of the software until it has as few bugs as possible so as not to undermine the user's patience. Uses very long release intervals which increase the user expectations for a perfect version.
	\item \textbf{Debugging:} takes a long time. A bug is a complicated and profound phenomenon. Only a small group of developers can solve them.
\end{itemize}
\textbf{The Bazaar}
\begin{itemize}
	\item \textbf{Development team:} composed of co-developers available via the internet. Contributors having different schedules and approaches, motivated by ego satisfaction, perception of constant improvements of the software coming from their works, personal needs, or love. Users can also be co-developers, helping to find, suggesting fixes, and improving code faster. Contributions are made by people who are sufficiently interested in using the software, learning how it works, trying to find solutions to the problems encountered, and actually producing a reasonable fix. The coordinator needs to be able to communicate well and attract good people. The developers are selfish agents who try to maximize their productivity and, during this process, spontaneously auto-organizing the development workflow.
	\item \textbf{Release process:} Make software versions available as soon as possible and as often as possible. Perfection is achieved when the code produced is not only efficient but also as simple as possible. Coding, enhancement, and debugging is parallelizable when the mode of development is based on rapid interactions.
	\item \textbf{Debugging:} Maximize the number of person-hours debugging and developing even if it costs code instability and introduction of an intractable bug. Given a sufficient number of testers and developers, almost all problems will be characterized quickly (by someone), and the solution will be evident to others. A bug is a superficial phenomenon (easily visualized), or is brought to the surface quickly when a version is available to several observers. Debugging is parallelizable and does not require much coordination, just a useful reference. In practice, debug rework (duplication) is rarely a problem, and this rework is reduced with increasing launch frequency. More users find more bugs because they can stress software in different ways. There is always the option to use a previous (stable) version if a critical bug is found in the current tree (unstable).
\end{itemize}

According to \cite{Raymond1999}, starting a project already with the shape of a
bazaar is not trivial since you need a plausible promise to create a community,
i.e., you need something executable and testable for this community. Raymond also
states that more important than being brilliant, a project coordinator should be
able to identify good ideas from other people's projects; to know when to restrict
the innovations and complexities in favour of code robustness and objectivity;
and to understand that the free software community values its reputation
and also puts pressure on people not to initiate development efforts that are not
worth moving forward.

\cite{Fogel2005} states that as a project gets older, it tends to move from a
benevolent dictatorship model to an openly democratic system with group-based
governance. This model would then be a ``consensus-based democracy'', where the
group works in consensus most of the time, and there is a formal voting
mechanism. Finally, after metamorphosing into a group-based system, a project
rarely moves back.

%% ------------------------------------------------------------------------- %%
\section{The Linux Kernel}
\label{sec:kernel}

%% ------------------------------------------------------------------------- %%
%\subsection{Linux, the Operating System Kernel}
%\label{sec:oskernel}

Linux is a monolithic kernel of the family of Unix-like operating system. It is
not a full Unix operating system since it not includes applications such as
filesystem utilities, windowing systems, desktop environment, text editors, and
compilers. Unlike Unix, Linux is under the GPL,
being open and available to anyone to study~\citep{Bovet2005}. This license
protects the code of commercial exploitation, and benefit it with the development
of the userspace project GNU.

According to \cite{Tanenbaum}, Linux is a rewrite of MINIX, with numerous ideas
from this microkernel project and other new features. The Linux kernel uses
modules to achieve microkernels advantages. A module is an object
file whose code is linked to the kernel at runtime. This object code usually
implements features at the kernel's upper layer~\citep{Bovet2005}.

\begin{figure}[ht]
	\centering
	\includegraphics[width=0.6\textwidth]{figure/linux_arch.png}
	\caption{An Overview of Linux Architecture}
        \label{fig:linux_arch}
\end{figure}	

The Linux kernel is divided into three levels, as shown in Figure 
\ref{fig:linux_arch}: the top-level implements basic functionalities of System
Call Interface, as read and write; the architecture-independent kernel code is
in the middle; and the architecture-dependent code is in the
bottom-level~\citep{ibm_kernel}.

%% ------------------------------------------------------------------------- %%
\subsection{The Linux Project}
\label{sec:linuxproject}

The Linux kernel project has currently over 6 million lines of code and much more
than 1000 active contributors from more than 100 different companies (or for no
company). Its development process differs greatly from proprietary development
methods, with a community-based scheme, a patch-oriented development process,
and a time-based release process.

%% ------------------------------------------------------------------------- %%
\subsubsection{Linux History}
\label{sec:linuxhistory}

Linux is an operating system kernel that began to be written by Linus Torvalds
in 1991~\citep{torvalds_1992}. It was initially private, but in 1992
Linus made it free software, enabling the GNU project to adopt this kernel and
thus creating the GNU/Linux operating system. The first stable version of
Linux (1.0) was released in 1994, with about 165,000 lines of code~\citep{Tanenbaum}. Due to the
full participation of the GNU community - concerned with the compatibility of
the system with the stable version of the kernel - and the dynamics of
geographically distributed volunteers coordinated by Torvalds, the project grew
to such an extent that, five years later, version 2.2.0 already had 1.8 million
lines of code~\citep{ibm_kernel}. 

Throughout its 28 years, the Linux creator, Linus Torvalds, has repositioned the
project regarding the Free Software and Open-Souce movements. In 2007, Torvalds
positioned itself against the adoption of GPLv3~\citep{torvalds_2007}, created by
the Free Software Foundation. More recently, in a TED of 2016, he stated that he
was never really concerned with following an open source methodology or free
software policies~\citep{ted_2016}. He just opened the code for feedback and created
methods and tools (such as Git) that made it possible to shape development in
the most comfortable possible way for him. Finally, in a letter recently sent to the
kernel project mailing list in 2018, Torvalds licenses himself for a brief period of
coordination of Linux due to strong disagreements with the community regarding
his way of conducting the project~\citep{torvalds_2018}.

%% ------------------------------------------------------------------------- %%
\subsubsection{The Project Structure}
\label{sec:linuxstructure}


\begin{figure}[ht]
	\centering
	\includegraphics[width=0.6\textwidth]{figure/linux_subsystems.pdf}
	\caption{Linux Subsystems}
        \label{fig:linux_sub}
\end{figure}	


The kernel code is organized as a set of subsystems (synthesized by Figure
\ref{fig:linux_sub}) such as process scheduler, memory
management, device driver infrastructure, networking, and filesystems~\citep{kernel_newbies}. Usually,
each subsystem has designated maintainers. A maintainer is the project role
responsible for managing and accepting contributions into a specific subsystem code.
The kernel project uses the Git source management tool to coordinate contributions.
These contributions (or patches) are grouped according to a particular need or
interest. This collection of patches are arranged in a tree. And each tree provides
a kind of place for the work to be developed.

A contribution sent to a subsystem does not go directly to the mainline tree of Linux. 
Each subsystem maintainer has a version of the kernel source tree, which enables
the maintainer to track patches. The chain of subsystem trees guides the flow of
patches to Torvalds' source tree~\citep{linux_corbet}. 
At the beginning of a development cycle, a ``window" is opened to
merge the code of changes accepted by the maintainers of a given subsystem into
the mainline kernel. After this time, Torvalds declares the window as closed and
releases a first intermediate release~\citep{kernel_process}. 
There is a somewhat informal process to ensure that a change is in the quality
and relevancy appropriate for the official repository. This evaluation is taken
by top-level maintainers and also by Torvalds. Sometimes, he takes
special attention to some particular patch; however, in general, he trusts
maintainers will not send bad code.

Notwithstanding the building of a chain-of-trust, the community has raised
questions the Torvalds behavior~\citep{torvalds_2018}, the hierarchies, and also the processes of review
and acceptance of changes~\citep{danvetter_post}. Such conflicts show the socio and behavioral aspects
that usually involve and impact the Linux kernel model and suggest that human presence
intrinsically put informalities, imprecisions, and unpredictability to FLOSS development.
